/* Copyright (C) 2008 Vincent Penquerc'h.
   This file is part of the Ogg/Kate codec library.
   Written by Vincent Penquerc'h.

   This file is preliminary code distributed only as a way to get
   feedback. As such, it is not meant to be finished quality, may
   not work, and streams encoded with it will certainly be unable
   to be decoded by any released version of the Ogg/Kate library.

   Since this code is not supposed to be used by third parties yet,
   there is no licence yet for this file, fair use applies.  */


#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <kate/kate.h>

int kate_get_version(void)
{
  return (KATE_VERSION_MAJOR<<16)|(KATE_VERSION_MINOR<<8)|KATE_VERSION_PATCH;
}

const char *kate_get_version_string(void)
{
  static char v[16]="";
  if (!*v) {
    snprintf(v,sizeof(v),"kate %d.%d.%d",KATE_VERSION_MAJOR,KATE_VERSION_MINOR,KATE_VERSION_PATCH);
    v[sizeof(v)-1]=0;
  }
  return v;
}

int kate_get_bitstream_version(void)
{
  return (KATE_BITSTREAM_VERSION_MAJOR<<8)|(KATE_BITSTREAM_VERSION_MINOR);
}

const char *kate_get_bitstream_version_string(void)
{
  static char v[32]="";
  if (!*v) {
    snprintf(v,sizeof(v),"kate bitstream %d.%d",KATE_BITSTREAM_VERSION_MAJOR,KATE_BITSTREAM_VERSION_MINOR);
    v[sizeof(v)-1]=0;
  }
  return v;
}

int kate_clear(kate_state *k)
{
  if (!k) return KE_INVALID_PARAMETER;

  return 0;
}

