/* Copyright (C) 2008 Vincent Penquerc'h.
   This file is part of the Ogg/Kate codec library.
   Written by Vincent Penquerc'h.

   This file is preliminary code distributed only as a way to get
   feedback. As such, it is not meant to be finished quality, may
   not work, and streams encoded with it will certainly be unable
   to be decoded by any released version of the Ogg/Kate library.

   Since this code is not supposed to be used by third parties yet,
   there is no licence yet for this file, fair use applies.  */


#include <stdlib.h>
#include <string.h>
#include <kate/kate.h>
#include "kate_decode_state.h"

kate_decode_state *kate_decode_state_create(const kate_info *ki)
{
  kate_decode_state *kds=(kate_decode_state*)kate_malloc(sizeof(kate_decode_state));
  kate_decode_state_clear(kds,ki,0);
  return kds;
}

int kate_decode_state_clear(kate_decode_state *kds,const kate_info *ki,int destroy)
{
  kate_event *ev;
  
  if (!kds || !ki) return KE_INVALID_PARAMETER;

  ev=&kds->event;

  if (destroy) {
    if (ev->language) kate_free(ev->language);
    kate_free(ev->text);
    if (ev->motion.curves) kate_free(ev->motion.curves);
    if (ev->motion.durations) kate_free(ev->motion.durations);
  }

  ev->granulepos=-1;
  ev->end_granulepos=-1;

  ev->text_encoding=ki->text_encoding;
  ev->language=NULL;
  ev->text=NULL;
  ev->len=0;

  ev->motion.ncurves=0;
  ev->motion.curves=NULL;
  ev->motion.durations=NULL;

  ev->region=0;
  ev->style=0;

  return 0;
}

int kate_decode_state_destroy(kate_decode_state *kds)
{
  if (!kds) return KE_INVALID_PARAMETER;
  kate_free(kds);
  return 0;
}
