/* Copyright (C) 2008 Vincent Penquerc'h.
   This file is part of the Ogg/Kate codec library.
   Written by Vincent Penquerc'h.

   This file is preliminary code distributed only as a way to get
   feedback. As such, it is not meant to be finished quality, may
   not work, and streams encoded with it will certainly be unable
   to be decoded by any released version of the Ogg/Kate library.

   Since this code is not supposed to be used by third parties yet,
   there is no licence yet for this file, fair use applies.  */


#include <stdlib.h>
#include <string.h>
#include <kate/kate.h>
#include "kate_encode_state.h"

kate_encode_state *kate_encode_state_create(void)
{
  kate_encode_state *kes=(kate_encode_state*)kate_malloc(sizeof(kate_encode_state));
  if (kes) {
    oggpack_writeinit(&kes->opb);
    kes->furthest_granule=0;
  }
  return kes;
}

int kate_encode_state_clear_overrides(kate_encode_state *kes,const kate_info *ki)
{
  if (!kes || !ki) return KE_INVALID_PARAMETER;

  kes->overrides.language=NULL;
  kes->overrides.text_encoding=ki->text_encoding;
  kes->overrides.region=-1;
  kes->overrides.style=-1;

  return 0;
}

int kate_encode_state_destroy(kate_encode_state *kes)
{
  if (!kes) return KE_INVALID_PARAMETER;
  oggpack_writeclear(&kes->opb);
  kate_free(kes);
  return 0;
}
