/* Copyright (C) 2008 Vincent Penquerc'h.
   This file is part of the Ogg/Kate codec library.
   Written by Vincent Penquerc'h.

   This file is preliminary code distributed only as a way to get
   feedback. As such, it is not meant to be finished quality, may
   not work, and streams encoded with it will certainly be unable
   to be decoded by any released version of the Ogg/Kate library.

   Since this code is not supposed to be used by third parties yet,
   there is no licence yet for this file, fair use applies.  */


#include <kate/kate.h>
#include "kate_granule.h"

/* this gives a space of 32 events at the same granule */
#define TIME_GRANULE_SHIFT 5

int kate_granule_shift(const kate_info *ki)
{
  if (!ki) return KE_INVALID_PARAMETER;
  return TIME_GRANULE_SHIFT;
}

ogg_int64_t kate_time_granule(const kate_info *ki,double t)
{
  if (!ki) return KE_INVALID_PARAMETER;
  return ((ogg_int64_t)(t*ki->gps_numerator/ki->gps_denominator))<<TIME_GRANULE_SHIFT;
}

ogg_int64_t granule2granule(const kate_info *ki,ogg_int64_t granule)
{
  if (!ki) return KE_INVALID_PARAMETER;
  return granule&~((1<<TIME_GRANULE_SHIFT)-1);
}

double kate_granule_time(const kate_info *ki,ogg_int64_t granulepos)
{
  if (!ki) return -1.0;
  return (granulepos>>TIME_GRANULE_SHIFT)*ki->gps_denominator/(double)ki->gps_numerator;
}
